## architecture-properties 0.1.1~cloud0

=== debian/changelog ===
architecture-properties (0.1.1~cloud0) jammy-bobcat; urgency=medium

  * New package for the Ubuntu Cloud Archive.

 -- Openstack Ubuntu Testing Bot <openstack-testing-bot@ubuntu.com>  Mon, 10 Jul 2023 18:31:14 +0000

architecture-properties (0.1.1) unstable; urgency=medium

  * Upload to unstable.

 -- Niels Thykier <niels@thykier.net>  Mon, 19 Dec 2022 20:52:18 +0000

architecture-properties (0.1) experimental; urgency=medium

  * Initial release.

 -- Niels Thykier <niels@thykier.net>  Wed, 14 Dec 2022 14:00:16 +0000

## architecture-properties 0.1.1~pgdg20.04+3

=== debian/changelog ===
architecture-properties (0.1.1~pgdg20.04+3) focal-pgdg; urgency=medium

  * Rebuild for focal-pgdg.
  * No source changes.

 -- PostgreSQL on Debian and Ubuntu <pgsql-pkg-debian@lists.postgresql.org>  Mon, 19 Dec 2022 20:52:18 +0000

## architecture-properties 0.1.1~pgdg22.04+3

=== debian/changelog ===
architecture-properties (0.1.1~pgdg22.04+3) jammy-pgdg; urgency=medium

  * Rebuild for jammy-pgdg.
  * No source changes.

 -- PostgreSQL on Debian and Ubuntu <pgsql-pkg-debian@lists.postgresql.org>  Mon, 19 Dec 2022 20:52:18 +0000

## architecture-properties 0.1.1~pgdg110+3

=== debian/changelog ===
architecture-properties (0.1.1~pgdg110+3) bullseye-pgdg; urgency=medium

  * Rebuild for bullseye-pgdg.
  * No source changes.

 -- PostgreSQL on Debian and Ubuntu <pgsql-pkg-debian@lists.postgresql.org>  Mon, 19 Dec 2022 20:52:18 +0000

=== debian/rules ===
#!/usr/bin/make -f

%:
	dh $@

execute_before_dh_gencontrol:
	echo "DEB-HOST-ARCH-BITS=$(DEB_HOST_ARCH_BITS)" >> debian/architecture-properties.substvars
	echo "DEB-HOST-ARCH-ENDIAN=$(DEB_HOST_ARCH_ENDIAN)" >> debian/architecture-properties.substvars

## architecture-properties 0.2.6

=== Makefile ===
# SPDX-License-Identifier: GPL-2.0-or-later
WRAPPER=$(DEB_HOST_GNU_TYPE)-cross-exe-wrapper
all:$(WRAPPER) cross-exe-wrapper.1 cross-exe-test
$(WRAPPER):cross-exe-wrapper.in
	sed \
		-e 's/#DEB_HOST_ARCH#/$(DEB_HOST_ARCH)/g' \
		-e 's/#DEB_HOST_MULTIARCH#/$(DEB_HOST_MULTIARCH)/g' \
		$< > $@
	chmod +x $@
cross-exe-wrapper.1:cross-exe-wrapper.in
	pod2man --name cross-exe-wrapper $< > $@
cross-exe-test:cross-exe-test.c
	$(CC) $(CFLAGS) $(CPPFLAGS) $(LDFLAGS) -o $@ $<
clean:
	$(RM) -- *-cross-exe-wrapper cross-exe-wrapper.1 cross-exe-test

## architecture-properties 0.1.1

=== debian/control ===
Source: architecture-properties
Section: devel
Priority: optional
Maintainer: Architecture Properties Maintainers <achitecture-properties@packages.debian.org>
Uploaders: Niels Thykier <niels@thykier.net>,
Build-Depends: debhelper-compat (= 13)
Rules-Requires-Root: no
Standards-Version: 4.6.1
Vcs-Git: https://salsa.debian.org/debian/architecture-properties.git
Vcs-Browser: https://salsa.debian.org/debian/architecture-properties

Package: architecture-properties
Architecture: any
Multi-Arch: same
Provides: architecture-is-${DEB-HOST-ARCH-BITS}-bit,
          architecture-is-${DEB-HOST-ARCH-ENDIAN}-endian
Description: Declarative architecture constraints
 This is a meta package that provide declarative architecture
 constraints like "architecture-is-64-bit" or
 "architecture-is-little-endian" for cases where architecture
 wildcard support in the Architecture field is insufficient.
 .
 Example usage: "Build-Depends: architecture-is-64-bit".
 .
 This package is provided solely for the purpose of being used
 in build-dependencies to simplify management of architecture
 support.

## architecture-properties 0.2.3

=== debian/changelog ===
architecture-properties (0.2.3) unstable; urgency=medium

  [ Simon McVittie ]
  * d/tests/foreign-cross-exe-wrapper: Suppress stderr of failing
    qemu-$arch. (Closes: #1081799)

 -- Niels Thykier <niels@thykier.net>  Fri, 20 Sep 2024 12:05:01 +0000

architecture-properties (0.2.2) unstable; urgency=medium

  [ Simon McVittie ]
  * d/tests/foreign-cross-exe-wrapper: Make sure rc is initialized
  * d/tests/control: Skip testing foreign-cross-exe-wrapper if qemu fails
    (Closes: #1081799)
  * d/tests: Install additional packages with --no-install-recommends

 -- Niels Thykier <niels@thykier.net>  Sun, 15 Sep 2024 05:31:39 +0000

architecture-properties (0.2.1) unstable; urgency=medium

  * Source-only upload now that 0.2 passed NEW.
  * Fixed some problems with the autopkgtests that were not possible
    to test with the current salsa-ci setup.
    Thanks Helmut Grohne <helmut@subdivi.de>

 -- Niels Thykier <niels@thykier.net>  Sat, 14 Sep 2024 09:56:23 +0000

architecture-properties (0.2) unstable; urgency=medium

  [ Christoph Berg ]
  * Fix typo in maintainer email address.

  [ Helmut Grohne ]
  * Add cross-exe-wrapper package and supporting packages
  * add autopkgtests for cross-exe-wrapper
  * cross-exe-wrapper.in: document exit codes of cross-exe-test
  * debian/rules: drop inclusion of architecture.mk
  * enable the default salsa-ci pipeline
  * cross-exe-test.c: fix FTBFS with gcc-14
  * cross-exe-wrapper: fix blhc
  * make autopkgtests skippable

 -- Niels Thykier <niels@thykier.net>  Fri, 13 Sep 2024 14:43:52 +0000

=== debian/control ===
--- 
+++ 
@@ -1,9 +1,9 @@
 Source: architecture-properties
 Section: devel
 Priority: optional
-Maintainer: Architecture Properties Maintainers <achitecture-properties@packages.debian.org>
+Maintainer: Architecture Properties Maintainers <architecture-properties@packages.debian.org>
 Uploaders: Niels Thykier <niels@thykier.net>,
-Build-Depends: debhelper-compat (= 13)
+Build-Depends: debhelper-compat (= 13), perl:any
 Rules-Requires-Root: no
 Standards-Version: 4.6.1
 Vcs-Git: https://salsa.debian.org/debian/architecture-properties.git
@@ -26,3 +26,51 @@
  in build-dependencies to simplify management of architecture
  support.
 
+Package: native-architecture
+Architecture: all
+Multi-Arch: no
+# Due to being M-A:no, this package can only ever satisfy native architecture
+# dependencies and that quite precisely is its purpose. Its Multi-Arch value
+# must not change even if the hinter says so.
+Description: Declarative native architecture constraint
+ This is a meta package that can only satisfy a dependency for the
+ native architecture. The native architecture is defined as the
+ architecture of the dpkg package by the Multi-Arch specification. By
+ depending on native-architecture, a client package can prevent its
+ installation for a non-native architecture.
+
+Package: native-architecture-is
+Architecture: any
+Multi-Arch: foreign
+Depends: native-architecture
+Provides: native-architecture-is-${DEB-HOST-ARCH}
+# Due to the dependency on native-architecture, this package can only ever be
+# installed for the native architecture. The native instance of this package
+# can always be installed. A dependency on native-architecture-is is thus
+# always satisfiable and thereby meaningless. The benefit of this package
+# arises from its Provides where the architecture constraint is lifted into the
+# package name.
+Description: Declarative native architecture assertions
+ This is a meta package that can be used to assert that a particular
+ architecture is native. The native architecture is defined as the
+ architecture of the dpkg package by the Multi-Arch specification. By
+ depending on e.g. native-architecture-is-amd64, a client package can
+ prevent its installation unless the native architecture is amd64.
+
+Package: cross-exe-wrapper
+Architecture: any
+Multi-Arch: same
+Depends:
+ ${shlibs:Depends},
+ native-architecture | native-architecture-is-amd64 [i386] | native-architecture-is-x32 [i386] | native-architecture-is-armhf [armel] | native-architecture-is-mips64el [mipsel] | native-architecture-is-ppc64 [powerpc] | native-architecture-is-sparc64 [sparc] | qemu-user | qemu-user-static,
+# The dependency ensures that either the architecture we use for installing is
+# the native architecture or the native architecture is sibling architecture of
+# the package architecture that is known to reliably run its code or a qemu is
+# installed. For instance, native-architecture-is-arm64 [armhf] is missing as
+# some recent arm64 CPUs no longer run 32bit code. The alternatives also ensure
+# that e.g. no qemu is required for installing cross-exe-wrapper:i386 on amd64
+# as we can reliably run i386 executables there without emulation.
+Description: Wrapper for executing binaries from other architectures
+ Provide a tool ${DEB_HOST_GNU_TYPE}-cross-exe-wrapper that can be
+ used to run ${DEB_HOST_ARCH} ELF executables on the current CPU
+ employing emulation technology if required.

## architecture-properties 0.2.5

=== debian/changelog ===
architecture-properties (0.2.5) unstable; urgency=medium

  * d/control: Clarify that the cross-exe-wrapper variables are intentional

 -- Niels Thykier <niels@thykier.net>  Sun, 26 Jan 2025 10:50:00 +0000

architecture-properties (0.2.4) unstable; urgency=medium

  * d/control: Expand variables in `cross-exe-wrapper`'s Description
    (Closes: #1094186)

 -- Niels Thykier <niels@thykier.net>  Sun, 26 Jan 2025 10:14:03 +0000

## architecture-properties 0.2.6

=== debian/changelog ===
architecture-properties (0.2.6) unstable; urgency=medium

  [ wuruilong ]
  * Please add support for loong64 (Closes: #1098935)

 -- Niels Thykier <niels@thykier.net>  Thu, 27 Feb 2025 07:00:56 +0000

=== debian/control ===
--- 
+++ 
@@ -71,6 +71,9 @@
 # that e.g. no qemu is required for installing cross-exe-wrapper:i386 on amd64
 # as we can reliably run i386 executables there without emulation.
 Description: Wrapper for executing binaries from other architectures
- Provide a tool ${DEB_HOST_GNU_TYPE}-cross-exe-wrapper that can be
+ Provides a tool ${DEB_HOST_GNU_TYPE}-cross-exe-wrapper that can be
  used to run ${DEB_HOST_ARCH} ELF executables on the current CPU
  employing emulation technology if required.
+ .
+ Since the tools are named per architecture, they should generally
+ always be referred to via the substituion variable as done above.

=== debian/rules ===
#!/usr/bin/make -f

%:
	dh $@

execute_before_dh_gencontrol:
	echo "DEB-HOST-ARCH-BITS=$(DEB_HOST_ARCH_BITS)" >> debian/architecture-properties.substvars
	echo "DEB-HOST-ARCH-ENDIAN=$(DEB_HOST_ARCH_ENDIAN)" >> debian/architecture-properties.substvars
	echo "DEB-HOST-ARCH=$(DEB_HOST_ARCH)" >> debian/native-architecture-is.substvars

=== debian/tests/control ===
Tests: native-cross-exe-wrapper
Depends: cross-exe-wrapper, dpkg-dev

Tests: sibling-cross-exe-wrapper
Architecture: amd64
Depends: cross-exe-wrapper
Restrictions: needs-root, breaks-testbed, skippable

Tests: foreign-cross-exe-wrapper
Depends: cross-exe-wrapper, dpkg-dev
Restrictions: needs-root, breaks-testbed, skippable

## architecture-properties 0.2.6build1

=== debian/changelog ===
architecture-properties (0.2.6build1) resolute; urgency=medium

  * No-change mass rebuild for Ubuntu 26.04 (LP: #2132257)

 -- Sebastien Bacher <seb128@ubuntu.com>  Sat, 06 Dec 2025 10:36:35 +0100
